﻿<%@ Page Language="C#" AutoEventWireup="true" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>WebDataGrid ViewState Size</title>
</head>
<body>
    <script runat="server" type="text/C#">
        
        public int PreviousLength
        {
            get
            {
                if (ViewState["PreviousLength"] != null)
                {
                    return (int)ViewState["PreviousLength"];
                }
                else return 0;
            }
            set { ViewState["PreviousLength"] = value; }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            // Get the base 64 encoded string ViewState value
            string value = Request.Form["__VIEWSTATE"];
            if (!string.IsNullOrEmpty(value))
            {
                // Current length
                int current = Convert.ToInt32(value.Length);

                lblVSSize.Text = string.Format("ViewState Length: {0}", current);

                // If the previous length is present, calculate the difference
                if (PreviousLength != 0)
                {
                    int difference = current - PreviousLength;
                    lblVSSize.Text += string.Format("<br />(Went up by {0} since last request.)", difference);
                }
                PreviousLength = current;
            }
        }

        protected void rdoGrid_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (rdoGrid.SelectedValue == "asp")
            {
                igGrid.Visible = false;
                aspGrid.Visible = true;
            }
            else
            {
                aspGrid.Visible = false;
                igGrid.Visible = true;
            }
        }
        
    </script>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager runat="server">
        </asp:ScriptManager>
        <asp:UpdatePanel runat="server">
            <ContentTemplate>
                <span style="font-size: 0.8em;">
                <b>Directions:</b> Click the 'Postback' button and notice the ViewState size grow larger with each request.  Switch to the Asp.net DataGrid, click the 'Postback' button, and notice the ViewState size levels out after a few requests.
                </span>
                <br /><br />
                <asp:RadioButtonList runat="server" ID="rdoGrid" OnSelectedIndexChanged="rdoGrid_SelectedIndexChanged"
                    AutoPostBack="true">
                    <asp:ListItem Text="Infragistics WebDataGrid" Value="ig" Selected="True" />
                    <asp:ListItem Text="Asp.net DataGrid" Value="asp" />
                </asp:RadioButtonList>
                <br />
                <ig:WebDataGrid runat="server" ID="igGrid" DataSourceID="sqlDataSource">
                    <Behaviors>
                        <ig:Sorting Enabled="true"></ig:Sorting>
                        <ig:Filtering Enabled="true"></ig:Filtering>
                    </Behaviors>
                </ig:WebDataGrid>
                <asp:DataGrid runat="server" ID="aspGrid" DataSourceID="sqlDataSource" Visible="false">
                </asp:DataGrid>
                <br />
                <asp:Label runat="server" ID="lblVSSize" EnableViewState="false"></asp:Label><br />
                <br />
                <asp:Button runat="server" ID="btnInPatients" Text="Postback" /><br />
                <asp:SqlDataSource runat="server" ID="sqlDataSource" ConnectionString="Data Source=(local)\SQL2K8;Integrated Security=true;"
                    SelectCommand="SELECT 'row1' as Column1,'row2' as Column2,'row3' as Column3,'row4' as Column4,'row5' as Column5,'row6' as Column6">
                </asp:SqlDataSource>
            </ContentTemplate>
        </asp:UpdatePanel>
    </div>
    </form>
</body>
</html>
